package Common;

//import static MDLUtilities.RunningBear.l;

public class Footers {

    public static final String[] SentenceFooter = {
        "import Common.GSentence;",
        "",
        "public class Sentence extends Common.GSentence<Domain,Arrow> {",
        "    ",
        "    public Sentence(String s) {",
        "        super(s);",
        "    }",
        "",
        "    @Override",
        "    public Domain getVoid() {",
        "        return Domain.Void;",
        "    }",
        "",
        "    @Override",
        "    public Domain getBool() {",
        "        return Domain.Bool;",
        "    }",
        "",
        "    @Override",
        "    public Domain getInt() {",
        "       return Domain.Int;",
        "    }",
        "",
        "    @Override",
        "    public Domain getStr() {",
        "       return Domain.Str;",
        "    }",
        "",
        "    @Override",
        "    public Domain[] values() {",
        "        return Domain.values();",
        "    }",
        "",
        "    @Override",
        "    public GSentence New(String s) {",
        "        return new Sentence(s);",
        "    }",
        "",
        "    @Override",
        "    public Arrow getEnd000() {",
        "                return Arrow.End000;",
        "    }",
        "",
        "    @Override",
        "    public Arrow getInt000() {",
        "        return Arrow.Int000;",
        "    }",
        "",
        "    @Override",
        "    public Arrow getStr000() {",
        "        return Arrow.Str000;",
        "    }",
        "",
        "    @Override",
        "    public Arrow getVarArr000() {",
        "        return Arrow.VarArr000;",
        "    }",
        "",
        "    @Override",
        "    public Arrow getVar000() {",
        "        return Arrow.Var000;",
        "    }",
        "",
        "    @Override",
        "    public Arrow[] arrowValues() {",
        "        return Arrow.values();",
        "    }",
        "",
        "    @Override",
        "    public String getClassName() {",
        "       String csvName = Thread.currentThread().getStackTrace()[1].getClassName() + \".csv\";",
        "       return csvName;",
        "    }",
        "}",
        "",
    };

    
    public static String[] ArrowFooter = {
        "    static final int len = 3;  // # of digits after true name",
        "  ",
        "    private final String nom;",
        "    private final Domain input;",
        "    private final Domain output;",
        "    private final ArrowType arrowtype;",
        "    private final Domain argType;",
        "    private final boolean processArgs;",
        "    private final Domain varType;",
        "    private final ParseArrowType parsearrowType;",
        "    private final int ln;",
        "    private final boolean user;",
        "    private String functor;    // can be updated",
        "    private final String parsetest;",
        "",
        "    private Arrow(Domain in, Domain out, ArrowType t, Domain argtype, Domain vartype, int ln, boolean usr, String funct, String parseTest) {",
        "        String n = name();",
        "        nom = n.substring(0, n.length() - len) + t.attach();",
        "        input = in;",
        "        output = out;",
        "        arrowtype = t;",
        "        argType = argtype; //Void;",
        "        processArgs = (t == ArrowType.hasArgs);",
        "        varType = vartype; //ull;",
        "        switch(n) {",
        "            case \"Var000\":",
        "            case \"Int000\": ",
        "            case \"Str000\":  parsearrowType = ParseArrowType.token; break;",
        "            case \"VarArr000\": parsearrowType = ParseArrowType.tokenArrow; break;",
        "            case \"End000\" : parsearrowType = ParseArrowType.end; break;",
        "            default:",
        "                parsearrowType = ParseArrowType.Default;",
        "        }",
        "        this.ln = ln;",
        "        user = usr;",
        "        functor = funct;",
        "        parsetest = parseTest;",
        "    }",
        "    ",
        "    private Arrow(Domain in, Domain out, ArrowType t, int ln, boolean usr, String funct, String parseTest) {",
        "        this(in,out,t,Domain.Void,null,ln,usr,funct,parseTest);",
        "    }",
        "    ",
        "    private Arrow(Domain in, Domain out, ArrowType t, Domain argtype,int ln,boolean usr, String funct, String parseTest) {",
        "        this(in,out,t,argtype,null,ln,usr,funct,parseTest);",
        "    }",
        "",
        "    // getters",
        "    @Override",
        "    public String nom() {",
        "        return nom;",
        "    }",
        "",
        "    @Override",
        "    public int nomLen() {",
        "        return nom.length();",
        "    }",
        "",
        "    @Override",
        "    public Domain in() {",
        "        return input;",
        "    }",
        "",
        "    @Override",
        "    public Domain out() {",
        "        return output;",
        "    }",
        "",
        "    @Override",
        "    public ArrowType arrowType() {",
        "        return arrowtype;",
        "    }",
        "",
        "    @Override",
        "    public Domain argType() {",
        "        return argType;",
        "    }",
        "",
        "    @Override",
        "    public Domain varType() {",
        "        return varType;",
        "    }",
        "    ",
        "    @Override",
        "    public boolean processArgs() { ",
        "        return processArgs;",
        "    }",
        "",
        "    @Override",
        "    public int ln() { ",
        "        return ln;",
        "    }",
        "",
        "    @Override",
        "    public boolean user() { ",
        "        return user;",
        "    }",
        "",
        "    @Override",
        "    public String functor() { ",
        "        return functor;",
        "    }",
        "",
        "    @Override",
        "    public String getClassName() {",
        "        String csvName = Thread.currentThread().getStackTrace()[1].getClassName() + \".csv\";",
        "        return csvName;",
        "    }",
        "",
//        "    @Override",
//        "    public void print(HashMap<String, String> hm) {",
//        "        System.out.format(\"%s(%s %s)-> %s\\n\",",
//        "              name(), input.name(), output.name(), hm.get(name()));",
//        "    }",
//        "    ",
        "    @Override",
        "    public void print() {",
        "        System.out.format(\"%s(%s %s)-> %s\\n\",name(), input, output, functor);",
        "    }",
        "",
        "    @Override",
        "    public Arrow[] ArrowValues() {",
        "        return Arrow.values();",
        "    }",
        "",
        "    @Override",
        "    public ParseArrowType getParseArrowType() {",
        "        return parsearrowType;",
        "    }",
        "",
        "    @Override",
        "    public String getParseTest() {",
        "        return parsetest;",
        "    }",
        "",
        "    public void set(String functorValue) {",
        "        functor = functorValue;",
        "    }",
        "",
        "   public static IArrow find(String name, Domain in, Domain out) {",
        "      for (Arrow a : Arrow.values()) {",
        "         if (a.input == in && a.output == out) {",
        "            String n = a.name();",
        "            n = n.substring(0, n.length() - len);",
        "            if (n.equals(name)) {",
        "               return a;",
        "            }",
        "         }",
        "      }",
        "      throw new RuntimeException(String.format(\"Cannot find Arrow (%s,%s,%s)\",name,in.toString(),out.toString()));",
        "   }",
        "",
        };

    public static String domainFooter[] = {
        "    // general",
        "    private final boolean start;",
        "    private final String nom;",
        "    private final int nomLen;",
        "",
        "    Domain(boolean b) {",
        "        start = b;",
        "        nom = name()+\".\";",
        "        nomLen = nom.length();",
        "    }",
        "",
        "    @Override",
        "    public String nom() { return nom; }",
        "    @Override",
        "    public int nomLen() { return nomLen; }",
        "    @Override",
        "    public boolean start() { return start; } ",
        "}"
    };
}
