/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package XformTools;

import PrologDB.DB;
import PrologDB.DBSchema;
import PrologDB.ErrorReport;
import PrologDB.Table;
import PrologDB.TableSchema;

/**
 *
 * @author don
 */
public class XformCommon {
    protected static ErrorReport er;
    protected static DB apl;
    protected static Table domain, attr, inh, assoc;
    protected static int aid = 0;
    
    protected static DB initAplDB(String appName, DBSchema as) {
        apl = new DB(appName, as);
        domain = apl.getTableEH("domain");
        attr = apl.getTableEH("attr");
        inh = apl.getTableEH("inh");
        assoc = apl.getTableEH("assoc");
        aid = 0;
        return apl;
    }

    protected static DBSchema MakeAplSchema() {
        DBSchema as = new DBSchema("all");
        as.add(new TableSchema("domain").add("id", "name", "prim:bool","computed:bool"));
        as.add(new TableSchema("attr").add("id", "domain", "name", "primtype","arrowtype","computed:bool"));
        as.add(new TableSchema("inh").add("id", "name", "super"));
        as.add(new TableSchema("assoc").add("id", "name", "input", "output", "computed:bool"));
        as.finishedAndIPropagatedAttributesMyself();
        return as;
    }
}
