package jrefact;

import MDLUtilities.Marquee2In_0Out;

public class SetUp {

    public static void main(String... args) {
        // Step 1: 
        Marquee2In_0Out mark = new Marquee2In_0Out(JRefact.class, ".class.violet", ".class.violet", args);
        String inputFileName = mark.getInputFileName();
        String inputFileName1 = mark.getInputFileName1();

        // Step 2: convert each .class.violet file to .fpl.pl fie
        convert(inputFileName, true);
        convert(inputFileName1, false);
        System.out.println("Done!");

    }

    static void convert(String classVioletFile, boolean isTop) {
        // Step 1: create names of files to be produced
        String appname = classVioletFile.replace(".class.violet", "");
        String appVpl = appname + ".vpl.pl";
        String appApl = appname + ".apl.pl";
        String appFpl = appname + ".fpl.pl";

        Violett.ClassParser.main(classVioletFile, appVpl);
        XformTools.Vpl2Apl.main(appVpl, appApl);
        if (isTop) {
            XformTools.Apl2Fpl.top(appApl, appFpl);
        } else {
            XformTools.Apl2Fpl.bot(appApl, appFpl);
        }
        System.out.format("file %s translated to %s\n",classVioletFile,appFpl);
    }
}
