package jrefact;

import XformTools.Apl2Fpl;
import org.junit.Before;
import org.junit.Test;


public class Apl2FplTest {
    
    static String correct = "test/jrefact/Correct/";
    static String testdata = "test/jrefact/TestData/";
    static String errout = "error.txt";
    static String fplOutput = "junk.fpl.pl";
    static String fplpl = ".fpl.pl";
    static String emptyCSV = "empty.extra.csv";
    
    public Apl2FplTest() {
    }
    
    @Before
    public void setUp() {
    }
    
    void doit(boolean top, String t) {
        if (top) Apl2Fpl.top(testdata+t+".apl.pl",testdata+emptyCSV, fplOutput);
        else     Apl2Fpl.bot(testdata+t+".apl.pl",testdata+emptyCSV, fplOutput);
        RegTest.Utility.validate(fplOutput,correct+t+fplpl, false);
    }

    @Test
    public void Bottom2() {
        doit(false, "Bottom2");
    }
    
    @Test
    public void T7() {
        doit(true,"T7");
    }
    
    @Test
    public void Top2() {
        doit(true,"Top2");
    }
}
