dbase(all,[domain,attr,inh,assoc]).

table(domain,[id,name,prim:bool,computed:bool]).
domain(Int,Int,TRUE,FALSE).
domain(Str,Str,TRUE,FALSE).
domain(Bool,Bool,TRUE,FALSE).
domain(Pair,Pair,TRUE,FALSE).
domain(Dept,Dept,FALSE,FALSE).
domain(Emp,Emp,FALSE,FALSE).
domain(State,State,FALSE,FALSE).
domain(Zip,Zip,FALSE,FALSE).

table(attr,[id,domain,name,primtype,arrowtype,computed:bool]).
attr(000,Dept,name,Str,field,FALSE).
attr(001,Emp,name,Str,field,FALSE).
attr(002,Emp,age,Int,field,FALSE).
attr(003,Emp,zip,Int,field,FALSE).
attr(004,Emp,city,Str,field,TRUE).
attr(005,Emp,state,Str,field,TRUE).
attr(006,State,state,Str,field,FALSE).
attr(007,Zip,zip,Int,field,FALSE).
attr(008,Zip,city,Str,field,FALSE).
attr(009,Zip,state,Str,field,FALSE).

table(inh,[id,name,super]).

table(assoc,[id,name,input,output,computed:bool]).
assoc(010,inZip,Emp,Zip,FALSE).
assoc(012,worksIn,Dept,Emp,FALSE).
assoc(014,inState,Zip,State,FALSE).
assoc(016,livesIn,Emp,State,TRUE).

