
package jrefact;

import PrologDB.Table;
import org.junit.Before;
import org.junit.Test;


public class JRefactTest {
    
    public JRefactTest() {
    }
    
    @Before
    public void setUp() {
    }

    /**
     * Test of main method, of class JRefact.
     */
    @Test
    public void testMain() {
        String[] files = {"Arrow.java","Domain.java","Sentence.java"};
        String[] dirs = {"src/Bottom/","src/Top/"};
        String CorrectAAO = "Correct/AAOutput/";
        String aa = "AAOutput/";
        String correct = "test/jrefact/Correct/";
        Table xcsv = Table.read(correct+"extra2.csv");
        Table ucsv = Table.read(correct+"update2.csv");
        jrefact.JRefact.main(correct+"Top2.fpl.pl",correct+"Bottom2.fpl.pl", xcsv,ucsv,null);  // TO FIX
        for (String d : dirs) {
            for (String f: files) {
                RegTest.Utility.validate(CorrectAAO+d+f,aa+d+f, false);
            }
        }
        String[] cxfiles = {"src/CEXCommon/BottomUpdate.java","src/CEXCommon/TopUpdate.java"};
        for (String f : cxfiles) {
            RegTest.Utility.validate(CorrectAAO+f, aa+f,false);
        }
        String[] tfiles = {"FunctorTest.java","ParseTest.java","RoundTripTest.java"};
        String[] tandb = {"Top","Bottom"};
        for (String tb : tandb) {
            for (String t: tfiles) {
                RegTest.Utility.validate(CorrectAAO+"test/"+tb+"/"+tb+t, aa+"test/"+tb+"/"+tb+t, true);
            }
        }
                
    }
    
}
