package Top;

import Common.GSentence;

public class Sentence extends Common.GSentence<Domain,Arrow> {
    
    public Sentence(String s) {
        super(s);
    }

    @Override
    public Domain getVoid() {
        return Domain.Void;
    }

    @Override
    public Domain getBool() {
        return Domain.Bool;
    }

    @Override
    public Domain getInt() {
       return Domain.Int;
    }

    @Override
    public Domain getStr() {
       return Domain.Str;
    }

    @Override
    public Domain[] values() {
        return Domain.values();
    }

    @Override
    public GSentence New(String s) {
        return new Sentence(s);
    }

    @Override
    public Arrow getEnd000() {
                return Arrow.End000;
    }

    @Override
    public Arrow getInt000() {
        return Arrow.Int000;
    }

    @Override
    public Arrow getStr000() {
        return Arrow.Str000;
    }

    @Override
    public Arrow getVarArr000() {
        return Arrow.VarArr000;
    }

    @Override
    public Arrow getVar000() {
        return Arrow.Var000;
    }

    @Override
    public Arrow[] arrowValues() {
        return Arrow.values();
    }

    @Override
    public String getClassName() {
       String csvName = Thread.currentThread().getStackTrace()[1].getClassName() + ".csv";
       return csvName;
    }
}

