package Top;

public enum Domain implements Common.IDomain {
    Void(false),
    Str(false),
    Int(false),
    Bool(false),
    Pair(false),
    $Str(true),
    $Int(true),
    $Bool(true),
    $Pair(true),

    //  Tables and Tuples
    $Bank(true),
    Bank(false),
    $Account(true),
    Account(false),
    $Vector(true),
    Vector(false),
    ;

    // general
    private final boolean start;
    private final String nom;
    private final int nomLen;

    Domain(boolean b) {
        start = b;
        nom = name()+".";
        nomLen = nom.length();
    }

    @Override
    public String nom() { return nom; }
    @Override
    public int nomLen() { return nomLen; }
    @Override
    public boolean start() { return start; } 
}
