dbase(all,[domain,attr,inh,assoc]).

table(domain,[id,name,prim:bool,computed:bool]).
domain(Int,Int,TRUE,FALSE).
domain(Str,Str,TRUE,FALSE).
domain(Bool,Bool,TRUE,FALSE).
domain(Dept,Dept,FALSE,FALSE).
domain(Emp,Emp,FALSE,FALSE).
domain(State,State,FALSE,FALSE).
domain(Zip,Zip,FALSE,FALSE).

table(attr,[id,domain,name,primtype,arrowtype,computed:bool]).
attr(0,Dept,name,Str,field,FALSE).
attr(1,Emp,name,Str,field,FALSE).
attr(2,Emp,age,Int,field,FALSE).
attr(3,Emp,zip,Int,field,FALSE).
attr(4,Emp,city,Str,field,TRUE).
attr(5,Emp,state,Str,field,TRUE).
attr(6,State,state,Str,field,FALSE).
attr(7,Zip,zip,Int,field,FALSE).
attr(8,Zip,city,Str,field,FALSE).
attr(9,Zip,state,Str,field,FALSE).

table(inh,[id,name,super]).

table(assoc,[id,name,input,output,computed:bool]).
assoc(10,inZip,Emp,Zip,FALSE).
assoc(12,worksIn,Dept,Emp,FALSE).
assoc(14,inState,Zip,State,FALSE).
assoc(16,livesIn,Emp,State,TRUE).

